<template>
  <div>
    <v-row class="mb-4 pa-0 ma-0">
      <v-col
        class="ma-0 pa-0"
        :class="desktop ? 'pr-4' : 'pb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="6"
        lg="6"
        xl="6"
      >
        <v-card class="pa-5" height="100%">
          <v-row
            width="100%"
            justify="start"
            align="center"
            class="mb-6 ma-0 pa-0"
          >
            <span class="title-idx-text-nowidth">Ranking Tway de </span>
            <span class="title-idx-text-nowidth ml-2 mr-4">
              Transformación Digital
            </span>
            <v-tooltip bottom>
              <template v-slot:activator="{ on, attrs }">
                <v-img
                  v-bind="attrs"
                  v-on="on"
                  class="image-percentage"
                  width="20px"
                  max-width="20px"
                  :src="require('@/assets/img/icons/info.svg')"
                />
              </template>
              <div>
                <span
                  >Aquí podrás ver tu posición y las de otras empresas
                  Especialistas en Transformación Digital</span
                >
              </div>
            </v-tooltip>
          </v-row>
          <v-row justify="center" align="center" v-if="!sector.checked">
            <v-img
              max-width="25%"
              :src="require('@/assets/img/icons/0_ranking.svg')"
            />
          </v-row>
          <v-row
            width="100%"
            justify="center"
            align="center"
            class="mb-2 mt- ma-0 pa-0"
            v-if="!sector.checked"
          >
            <span class="sub-title-no-ranking">Tu Posición en Tway</span>
          </v-row>
          <v-row
            width="100%"
            justify="start"
            align="center"
            class="mb-1 ma-0 pa-0"
            v-if="!sector.checked"
          >
            <span class="no-ranking-text"
              >Para saber tu posición en Tway, debes completar los datos de tu
              perfil.</span
            >
          </v-row>
          <v-row
            width="100%"
            justify="center"
            align="center"
            class="ma-0 mt-4 pa-0"
            v-if="!sector.checked"
          >
            <v-btn
              depressed
              rounded
              color="#16C62E"
              class="button-text white--text"
              :to="{ name: 'complete-profile' }"
            >
              COMPLETAR PERFIL
            </v-btn>
          </v-row>
          <v-row
            class="mb-6 ma-0 pa-0"
            width="100%"
            justify="start"
            align="center"
            v-if="sector.checked"
          >
            <div class="mr-4 place-icon-first">
              <span>{{ rankingGlobalNumber }}</span>
              <v-img
                class="image-percentage"
                width="70px"
                max-width="70px"
                :src="require('@/assets/img/icons/place.svg')"
              />
            </div>
            Tu Posición en Tway
          </v-row>
          <v-container fluid class="ma-0 pa-0" v-if="sector.checked">
            <v-row
              v-for="(element, elementIndex) in rankingGlobal"
              :key="elementIndex"
              class="mb-1 ma-0 pa-0"
              width="100%"
              justify="space-between"
              align="center"
            >
              <div
                style="
                  display: flex;
                  flex-direction: row;
                  align-items: center;
                  max-width: 80% !important;
                  overflow: hidden;
                "
              >
                <div
                  :style="'opacity: ' + (1 - elementIndex / 5) + ';'"
                  class="mr-2 place-icon"
                >
                  <span>{{ elementIndex + 1 }}</span>
                  <v-img
                    class="image-percentage"
                    width="50px"
                    max-width="50px"
                    :src="require('@/assets/img/icons/place.svg')"
                  />
                </div>
                <span style="color: #333333" class="roboto" v-if="element.name">
                  <div style="white-space: nowrap; overflow: hidden">
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <span v-bind="attrs" v-on="on">{{ element.name }}</span>
                      </template>
                      <span>{{ element.name }}</span>
                    </v-tooltip>
                  </div>
                </span>
              </div>
              <span style="color: #333333" class="roboto"
                >{{ toFixed(element.score * 10, 0) }}%</span
              >
            </v-row>
          </v-container>
        </v-card>
      </v-col>
      <v-col class="ma-0 pa-0" cols="12" xs="12" sm="12" md="6" lg="6" xl="6">
        <v-card class="pa-5" height="100%">
          <v-row
            width="100%"
            justify="start"
            align="center"
            class="mb-6 ma-0 pa-0"
          >
            <span class="title-idx-text-nowidth mr-4">Impacto por Sector </span>
            <v-tooltip bottom>
              <template v-slot:activator="{ on, attrs }">
                <v-img
                  v-bind="attrs"
                  v-on="on"
                  class="image-percentage"
                  width="20px"
                  max-width="20px"
                  :src="require('@/assets/img/icons/info.svg')"
                />
              </template>
              <div>
                <span
                  >Aquí podrás ver el Nivel de Impacto de los servicios que
                  ofreces en el sector</span
                >
              </div>
            </v-tooltip>
          </v-row>
          <v-row
            class="ma-0 pa-0"
            :style="
              mobile
                ? 'margin-right: -11% !important;'
                : 'margin-right: -8% !important;'
            "
            justify="center"
          >
            <v-row
              :style="
                mobile ? 'max-width: 75%;' : 'max-width: 70%; z-index: 10;'
              "
              class="ma-0 pa-0"
              justify="space-between"
            >
              <div
                style="
                  text-align: center;
                  font-size: 10px;
                  margin-bottom: -20% !important;
                  display: flex;
                  justify-content: center;
                  align-items: center;
                  flex-direction: column;
                "
              >
                <span> ANÁLOGO </span>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-img
                      v-bind="attrs"
                      v-on="on"
                      class="image-percentage"
                      width="20px"
                      height="20px"
                      max-height="20px"
                      max-width="20px"
                      :src="require('@/assets/img/icons/info.svg')"
                    />
                  </template>
                  <div>
                    <span>Nivel Básico</span>
                  </div>
                </v-tooltip>
              </div>
              <div
                style="
                  text-align: center;
                  font-size: 10px;
                  display: flex;
                  justify-content: center;
                  align-items: center;
                  flex-direction: column;
                "
              >
                <span>DIGITAL</span>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-img
                      v-bind="attrs"
                      v-on="on"
                      class="image-percentage"
                      width="20px"
                      height="20px"
                      max-height="20px"
                      max-width="20px"
                      :src="require('@/assets/img/icons/info.svg')"
                    />
                  </template>
                  <div>
                    <span>Nivel Inicial y Estratégico</span>
                  </div>
                </v-tooltip>
              </div>
              <div
                style="
                  text-align: center;
                  font-size: 10px;
                  margin-bottom: -20% !important;
                  display: flex;
                  justify-content: center;
                  align-items: center;
                  flex-direction: column;
                "
              >
                <span>
                  EN
                  <br />
                  TRANSFORMACIÓN
                </span>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-img
                      v-bind="attrs"
                      v-on="on"
                      class="image-percentage"
                      width="20px"
                      height="20px"
                      max-height="20px"
                      max-width="20px"
                      :src="require('@/assets/img/icons/info.svg')"
                    />
                  </template>
                  <div>
                    <span>Nivel Competitivo</span>
                  </div>
                </v-tooltip>
              </div>
            </v-row>
          </v-row>
          <v-row class="ma-0 py-4 pa-0" justify="center">
            <div
              class="gauge"
              :style="
                'width: 200px; --rotation:70deg; --rotationdiv:' +
                (flagRanking == 1
                  ? ((odometer * 180) / 100).toString()
                  : odometerDti) +
                'deg; --color:#E57373; --background:#e9ecef;'
              "
            >
              <div class="percentage" />
              <div
                style="transform: rotate(50deg); background-color: #ffee58"
                class="percentage"
              />
              <div
                style="transform: rotate(130deg); background-color: #8ae296"
                class="percentage"
              />
              <div class="mask" />
              <span class="value">
                <div>
                  <div><div /></div>
                </div>
              </span>
            </div>
          </v-row>
          <v-row
            width="100%"
            justify="center"
            align="center"
            class="mb-6 ma-0 pa-0"
          >
            <v-btn
              depressed
              rounded
              small
              :color="flagRanking == 1 ? '#DCC5F4' : '#f1f1f1'"
              @click="
                () => {
                  flagRanking = 1;
                }
              "
              class="roboto mr-2"
              :style="
                (flagRanking == 1 ? 'color: #7319D5;' : 'color: #999999;') +
                ' text-transform: capitalize; font-size: 14px;'
              "
            >
              Servicios
            </v-btn>
            <v-btn
              depressed
              rounded
              small
              :color="flagRanking == 2 ? '#DCC5F4' : '#f1f1f1'"
              class="roboto"
              @click="
                () => {
                  flagRanking = 2;
                }
              "
              :style="
                (flagRanking == 2 ? 'color: #7319D5;' : 'color: #999999;') +
                ' text-transform: capitalize; font-size: 14px;'
              "
            >
              <span>Facilitador</span>
            </v-btn>
          </v-row>
          <div v-if="flagRanking == 1" class="roboto text-center text-impacto">
            Los servicios que ofreces tienen este impacto en las dimensiones
            <strong
              v-for="(dimension, dimensionIndex) in odometerDimensions"
              :key="dimensionIndex"
              >{{ dimension.name
              }}<span v-if="dimensionIndex != odometerDimensions.length - 1"
                >,
              </span> </strong
            >.
          </div>
          <div v-else class="roboto text-center text-impacto">
            <span v-if="dtiFacilitador <= 40">
              Apalancar la gestión de negocio en la digitalización. Generar
              inteligencia compartida para operaciones, ventas, productos y
              servicios. Alinear tecnologías y sistemas para que las áreas
              operen conectadas y ágiles. Usar tecnología para entender los
              cambios en mercado y comportamiento de clientes.
            </span>
            <span v-if="dtiFacilitador > 40 && dtiFacilitador <= 60">
              Apalancar más del 40% de la gestión de negocio en digitalización.
              Procesar data para identificar problemas operacionales y conducir
              innovación. Incorporar herramientas digitales colaborativas y
              automatizadas para innovar. Monitorear la satisfacción del cliente
              en tiempo real y proyectar el negocio.
            </span>
            <span v-if="dtiFacilitador > 60 && dtiFacilitador <= 80">
              Apalancar más de 60% de la gestión del negocio en innovaciones
              digitales. Integrar nuevos proyectos estratégicos de análisis,
              automatización e inteligencia para optimizar procesos, cadenas de
              suministro y operaciones confiables, agilizando la capacidad de
              respuesta al mercado y clientes.
            </span>
            <span v-if="dtiFacilitador > 80">
              Apalancar sobre 80% de la gestión de negocio en innovaciones
              digitales. Mejorar la propuesta de valor con tecnologías
              avanzadas, en la nube, procesos automatizados y herramientas de
              colaboración. Usar la data para ajustar el mix de productos,
              acelerar salida al mercado y optimizar la experiencia de clientes.
            </span>
          </div>
          <v-row
            width="100%"
            justify="center"
            align="center"
            class="ma-0 mt-4 pa-0"
          >
            <v-btn
              depressed
              rounded
              color="#16C62E"
              class="white--text"
              :to="{ name: 'plans' }"
            >
              ver planes
            </v-btn>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="mb-4 pa-0 ma-0">
      <v-col
        class="ma-0 pa-0"
        :class="desktop ? 'pr-4' : 'pb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="7"
        lg="7"
        xl="7"
      >
        <v-card class="pa-5" height="100%">
          <v-row
            width="100%"
            justify="start"
            align="center"
            class="mb-6 ma-0 pa-0"
          >
            <span class="title-idx-text-nowidth mr-4"
              >Benchmark Especialistas Tway
            </span>
            <v-tooltip class="tooltip" bottom>
              <template v-slot:activator="{ on, attrs }">
                <v-img
                  v-bind="attrs"
                  v-on="on"
                  class="image-percentage"
                  width="20px"
                  max-width="20px"
                  :src="require('@/assets/img/icons/info.svg')"
                />
              </template>
              <div>
                <span
                  >Aquí podrás ver algunas posiciones según las Propuestas de
                  Valor en Tway</span
                >
              </div>
            </v-tooltip>
          </v-row>
          <v-row class="ma-0 pa-0" align="stretch" style="height: 85%">
            <v-col
              cols="12"
              xs="12"
              sm="12"
              md="4"
              lg="4"
              xl="4"
              :class="desktop ? 'pr-2' : ''"
              class="pb-4 pa-0"
            >
              <v-card
                color="#9652DF"
                class="white--text rounded-xl pa-5 center-full"
              >
                <div>
                  <v-row
                    class="mb-6 ma-0 pa-0"
                    width="100%"
                    justify="center"
                    align="center"
                  >
                    <div class="mr-2 place-icon-first">
                      <span v-if="sector.checked" class="white--text">{{
                        rankingClientYear
                      }}</span>
                      <v-img
                        class="image-percentage"
                        width="70px"
                        max-width="70px"
                        :src="require('@/assets/img/icons/place-white.svg')"
                        v-if="sector.checked"
                      />

                      <v-img
                        width="70px"
                        max-width="70px"
                        :src="require('@/assets/img/icons/0_ranking_white.svg')"
                        v-if="!sector.checked"
                      />
                    </div>
                  </v-row>
                  <span v-if="sector.checked" class="no-ranking-text">
                    Tu posición en el ranking según tus años de experiencia
                  </span>
                  <span v-if="!sector.checked" class="no-ranking-text">
                    Para saber tu posición según tus años de experiencia, debes
                    completar este dato en tu perfil.
                  </span>
                </div>
              </v-card>
            </v-col>
            <v-col
              cols="12"
              xs="12"
              sm="12"
              md="4"
              lg="4"
              xl="4"
              class="pb-4 pa-0"
            >
              <v-card
                color="#B98CEA"
                class="white--text rounded-xl pa-5 center-full"
              >
                <div>
                  <v-row
                    class="mb-6 ma-0 pa-0"
                    width="100%"
                    justify="center"
                    align="center"
                  >
                    <div class="mr-2 place-icon-first">
                      <span class="white--text" v-if="sector.checked">{{
                        rankingClientSize
                      }}</span>
                      <v-img
                        class="image-percentage"
                        width="70px"
                        max-width="70px"
                        :src="require('@/assets/img/icons/place-white.svg')"
                        v-if="sector.checked"
                      />
                      <v-img
                        width="70px"
                        max-width="70px"
                        :src="require('@/assets/img/icons/0_ranking_white.svg')"
                        v-if="!sector.checked"
                      />
                    </div>
                  </v-row>
                  <span v-if="sector.checked" class="no-ranking-text">
                    Tu posición en el ranking según el tamaño de tu empresa
                  </span>
                  <span v-if="!sector.checked" class="no-ranking-text">
                    Para saber tu posición según el tamaño de tu empresa, debes
                    completar este dato en tu perfil.
                  </span>
                </div>
              </v-card>
            </v-col>
            <v-col
              cols="12"
              xs="12"
              sm="12"
              md="4"
              lg="4"
              xl="4"
              :class="desktop ? 'pl-2' : ''"
              class="pb-4 pa-0"
            >
              <v-card
                color="#DCC5F4"
                class="white--text rounded-xl pa-5 center-full"
              >
                <div>
                  <v-row
                    class="mb-6 ma-0 pa-0"
                    width="100%"
                    justify="center"
                    align="center"
                  >
                    <div class="mr-2 place-icon-first">
                      <v-img
                        class="image-percentage"
                        width="70px"
                        max-width="70px"
                        :src="require('@/assets/img/icons/user-admin.svg')"
                      />
                    </div>
                  </v-row>
                  <span>
                    <strong
                      >Nivel <br />
                      <span v-if="clientLevel">{{ clientLevel }}</span>
                      <v-progress-circular
                        v-else
                        indeterminate
                        :size="20"
                        :width="2"
                        color="white"
                      />
                    </strong>
                    <br />
                    En Cliente
                  </span>
                </div>
              </v-card>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-col class="ma-0 pa-0" cols="12" xs="12" sm="12" md="5" lg="5" xl="5">
        <v-card class="pa-5" height="100%">
          <v-row width="100%" justify="start" align="center" class="ma-0 pa-0">
            <span class="title-idx-small"
              >Servicios más solicitados en Tway</span
            >
            <v-tooltip bottom>
              <template v-slot:activator="{ on, attrs }">
                <v-img
                  v-bind="attrs"
                  v-on="on"
                  class="info-services"
                  width="20px"
                  max-width="20px"
                  :src="require('@/assets/img/icons/info.svg')"
                />
              </template>
              <div>
                <span
                  >Aquí podrás ver los Servicios más requeridos para mejorar el
                  Índice de Transformación Digital</span
                >
              </div>
            </v-tooltip>
          </v-row>
          <v-container fluid class="ma-0 pa-0">
            <v-row
              v-for="(element, elementIndex) in rankingServices"
              :key="elementIndex"
              :style="
                'font-size: ' + (30 - elementIndex * 2) + 'px !important;'
              "
              class="mb-1 ma-0 pa-0"
              width="100%"
              justify="space-between"
              align="center"
            >
              <div
                style="display: flex; flex-direction: row; align-items: center"
              >
                <strong style="color: #7319d5" class="roboto mr-4">{{
                  element
                }}</strong>
              </div>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>

<style scoped lang="scss">
.no-ranking-text {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal !important;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
}

.sub-title-no-ranking {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 20px;
  color: #999999;
}

.gauge {
  position: relative;
  border-radius: 50%/100% 100% 0 0;
  background-color: var(--color, #a22);
  overflow: hidden;
}
.gauge:before {
  content: "";
  display: block;
  padding-top: 50%; /* ratio of 2:1*/
}
.gauge .chart {
  overflow: hidden;
}
.gauge .mask {
  position: absolute;
  left: 20%;
  right: 20%;
  bottom: 0;
  top: 40%;
  background-color: #fff;
  border-radius: 50%/100% 100% 0 0;
}

.gauge .percentage {
  position: absolute;
  top: -1px;
  left: -1px;
  bottom: 0;
  right: -1px;
  background-color: var(--background, #aaa);
  transform: rotate(var(--rotation));
  transform-origin: bottom center;
  transition-duration: 600;
}
.gauge:hover {
  --rotation: 100deg;
}
.gauge .value {
  position: absolute;
  bottom: 0%;
  left: 0;
  transform: rotate(var(--rotationdiv));
  width: 100%;
  text-align: center;
  display: flex;
  justify-content: center;
  > div {
    width: 65%;
    display: flex;
    justify-content: flex-start;
    > div {
      background-color: #333333;
      height: 5px;
      border-radius: 999em !important;
      width: 50%;
      text-align: center;
      display: flex;
      justify-content: flex-end;
      > div {
        height: 12px;
        width: 12px;
        background-color: #333333;
        border-radius: 100%;
        margin-top: -5%;
        margin-right: -8%;
      }
    }
  }
}

.gauge .min {
  position: absolute;
  bottom: 0;
  left: 5%;
}
.gauge .max {
  position: absolute;
  bottom: 0;
  right: 5%;
}

.no-dashboard-text {
  font-size: 16px;
  line-height: 24px;
  font-weight: 400;
  text-align: center;
}

.small-btn-text-1 {
  font-size: 10px;
  color: #7319d5;
}

.small-btn-text-2 {
  font-size: 10px;
  color: #999999;
}

.center-text {
  text-align: center !important;
}

.text-impacto {
  font-size: 16px;
}

.title-idx-text {
  font-size: 23px;
  width: 100%;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.center-full {
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  > div {
    > span {
      strong {
        font-size: 20px !important;
      }
      text-align: center;
      min-height: 100px;
      font-weight: 600;
      font-size: 17px;
    }
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
  }
}

.title-idx-small {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 22px;
  line-height: 30px;
  .element {
    text-transform: lowercase;
  }
  text-align: start;
}

.title-idx-text-nowidth {
  font-size: 23px;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.title-idx-text-subtitle {
  color: #999999;
  font-size: 18px;
  .element {
    text-transform: lowercase;
  }
  line-height: 30px;
  font-weight: 400;
  text-align: start;
}

.place-icon {
  display: flex;
  flex-direction: column;
  align-items: center;
  span {
    margin-bottom: -37px;
    font-size: 26px;
    font-weight: bold;
    color: #7319d5;
  }
}

.place-icon-first {
  display: flex;
  flex-direction: column;
  align-items: center;
  span {
    margin-bottom: -50px;
    font-size: 35px;
    font-weight: bold;
    color: #16c62e;
  }
}

.title-idx-subtitle {
  font-size: 25px;
  line-height: 30px;
  font-weight: 700;
  text-align: start;
  color: #7319d5;
}

.item-title {
  font-size: 12px;
  line-height: 14px;
  width: 100%;
  font-weight: 400;
  text-align: start;
  cursor: pointer;
}

.item-title:hover,
.item-title:focus {
  color: rgba(#000, 0.6);
}

.item-score {
  font-size: 30px;
  width: 100%;
  line-height: 14px;
  font-weight: 400;
  color: #333333;
  text-align: start;
}

.item-score-danger {
  font-size: 30px;
  width: 100%;
  color: #b71c1c;
  line-height: 14px;
  font-weight: 400;
  text-align: start;
}

.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}

.chip-text {
  color: #666666;
}

.body-idx-text {
  font-size: 16px;
  line-height: 20px;
  font-weight: 400;
  text-align: start;
  color: rgba(#000, 0.8);
}

.pertentage-text {
  color: #4a148c;
  font-size: 50px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.pertentage-text-danger {
  color: #b71c1c;
  font-size: 50px;
  line-height: 82.03px;
  text-align: center;
  font-weight: 700;
}

.full-height {
  height: 100%;
}

.border-bottom {
  border-bottom: 1px solid #dedede;
}

.worse-title {
  color: #7319d5;
  text-transform: lowercase;
}

.worse-text {
  font-size: 16px;
}

.info-services {
  margin-left: 10px;
}
</style>

<script>
import dtService from "@/services/dtService";
import currentUserService from "@/services/currentUserService";
import CompanyService from "@/services/companyService";
import { mapActions, mapGetters } from "vuex";

export default {
  components: {},

  data: () => ({
    sector: {},
    flagRanking: 1,
    percentage: {
      value: 0,
      name: "Madurez en Transformación Digital",
      index: true,
    },

    odometer: 0,
    odometerDti: 0,
    odometerDimensions: [],
    rankingClientSize: 0,
    rankingClientYear: 0,
    rankingGlobal: [],
    rankingServices: [
      "Marketing Digital",
      "Diseño UX/UI",
      "Experiencia Cliente",
      "Ciberseguridad",
      "Tecnologías Inteligentes",
      "Servicio Infraestructura TI",
      "Gestión Servicios TI",
      "Servicios TI Gobernanza",
      "Automatización de Procesos",
      "Data y Analitica",
    ],
    rankingGlobalNumber: 0,
    levels: [
      "La empresa enfrenta el futuro con mentalidad mayoritariamente analógica, sin plan digital. Suma innovaciones aisladas. Opera con sistemas rígidos y poco eficientes para adaptarse a los intereses de los clientes y del mercado. Aspira a incorporar la Transformación Digital, pero las decisiones son tardías y lentas. Falta un liderazgo que impulse el proceso de transformación. Aparecen resistencias. La organización persiste en hacer las cosas como hasta ahora, sin integrar competencias digitales. La organización está enfocada en una rentabilidad de corto plazo. Su competitividad futura es baja.",
      "La empresa integra innovaciones en procesos específicos para bajar costos y aumentar margen. Resuelve problemas actuales con tecnologías, más que cambiar la forma de hacer las cosas. Pone en marca acciones digitales, sin claridad sobre el valor que tendrán en el negocio futuro.\n\nPersisten resistencias y una cultura de trabajo en silos, sin lograr agilizar la transformación digital, ni impregnar a toda la organización. Necesita un propósito alineado a un proyecto digital estructurado, y liderazgos comprometidos con una ruta hacia la Transformación integral. \n\nIncorpora competencias digitales para adoptar nuevos modelos de negocio. Pone en marcha algunos servicios con foco en los clientes y su comportamiento, priorizando acciones de marketing.",
      "La empresa alinea su propósito a la Transformación Digital como estrategia de negocio. \n\nProyecta una cultura orientada al cliente y data driven, para tomar decisiones, escalar el negocio, aumentar la velocidad de salida al mercado y adaptar la propuesta de valor a escenarios dinámicos. \n\nEstablece liderazgos comprometidos con los cambios. Incorpora modelos de aprendizaje continuo. Impulsa la colaboración entre equipos autónomos y multidisciplinarios. Establece alianzas con ecosistemas externos para lograr eficiencias y mejorar la rentabilidad futura.\n\nLa data, innovación y las tecnologías son activos estratégicos transversales para volverse más ágil, automatizar procesos y escalar. Mapea la experiencia de los clientes de principio a fin, monitorea su satisfacción, interactúa con ellos en espacios digitales y gestiona activamente fallas operacionales.",
      "La estrategia, proyecto y gestión de Transformación Digital es central y transversal. Completamente integrada al negocio, busca crear ventajas competitivas a largo plazo en contextos dinámicos. La tecnología es su aliado en la nube. \n\nPromueve una nueva mentalidad a través de un propósito vinculante, potenciando una inteligencia colectiva. Nace una cultura corporativa flexible, auto motivada y abierta a la innovación. Surgen liderazgos que permiten orquestar los cambios de forma ágil, distribuyendo las decisiones críticas. \n\nCuenta con un ecosistema que incentiva el aprendizaje continuo, incorporando los errores o fallos de forma constructiva, prototipando para escalar rápido. \n\nLos clientes son entendidos como una red, los conecta de manera multicanal y sin fricciones, motivándolos a colaborar en crear su oferta de valor. La data es un activo para conocerlos y anticiparse a la futura interacción que tendrán con sus productos y servicios; el fin, entregar una experiencia exitosa.",
    ],
    dimensions: [
      {
        value: 0,
        name: "MODELO DE NEGOCIO",
        image: "bars.svg",
        id: "",
        description:
          "Cuestionar los actuales diferenciadores de negocio y proyectar a la competencia como socio colaborativo para fortalecer la propuesta de valor futura. Compartir data financiera y operacional al interior de la organización.Mapear el viaje del cliente y su soporte, la cadena de suministro, canales de distribución y posibles alianzas para impulsar oportunidades, bajar costos y actuar ágil al incoprorar tecnologías, data e innovaciones.",
      },
      {
        value: 0,
        name: "FACILITADORES",
        image: "console.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
      {
        value: 0,
        name: "MENTALIDAD",
        image: "users.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
      {
        value: 0,
        name: "ORQUESTACIÓN",
        image: "barsup.svg",
        id: "",
        description:
          "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam eligendi hic in accusamus quasi, consectetur voluptate tempore esse neque a dicta quaerat veniam, consequuntur sequi, vel aspernatur sed nemo magni!",
      },
    ],
    isLoading: true,
    complete: false,
    dti: {
      score: 0,
      dimensions: [],
    },
    dtiFacilitador: 0,
    selectedDimension: null,
    series: [
      {
        data: [0, 0, 0, 0],
      },
    ],
    chartOptions: {
      chart: {
        toolbar: {
          show: false,
        },
      },
      xaxis: {
        categories: [
          ["ORQUESTACIÓN"],
          ["MODELO", "DE", "NEGOCIO"],
          "FACILITADORES",
          ["MENTALIDAD"],
        ],
      },
      stroke: {
        show: true,
        width: 2,
        colors: ["#15c62e"],
        dashArray: 0,
      },
      markers: {
        size: 0,
        hover: {
          size: 10,
        },
      },
      fill: {
        opacity: 0.15,
        colors: ["#7D00FF"],
      },
      plotOptions: {
        radar: {
          size: 80,
          offsetX: 0,
          offsetY: 0,
          polygons: {
            strokeColors: "#e9dbf9",
            strokeWidth: 1,
            strokeDash: 4,
            connectorColors: "#DCC5F4",
            fill: {
              colors: undefined,
            },
          },
        },
      },
      labels: {
        show: true,
        style: {
          colors: ["#000000"],
          fontSize: "13px",
          fontFamily: "Roboto Condensed",
        },
      },
    },
  }),

  created() {
    currentUserService
      .currentUserData()
      .then((userData) => {
        this.user = userData;
        dtService
          .getSurveyComplete("a123", this.user.id)
          .then((questions) => {
            this.SET_PERCENTAGE(
              Math.floor((questions.answered / questions.total) * 100)
            );
            if (this.getPercentage != 100) {
              this.finishLoading();
            } else {
              this.getDti(this.user.id, questions.surveyId);
            }
          })
          .catch((err) => {
            this.$log.error(err);
          });
      })
      .catch((err) => this.$log.error(err));
  },

  methods: {
    ...mapActions("UserStore", ["SET_PERCENTAGE"]),
    finishLoading() {
      this.$emit("finishloading");
    },
    toFixed(num, fixed) {
      var re = new RegExp("^-?\\d+(?:\\.\\d{0," + (fixed || -1) + "})?");
      return num.toString().match(re)[0];
    },
    changePercentage(index) {
      this.percentage = {
        name: this.dimensions[index].name,
        value: this.dimensions[index].value,
        index: false,
      };
    },
    getDti(userId, surveyId) {
      CompanyService.getRankingYears()
        .then((ranking) => {
          this.rankingClientYear = ranking;
        })
        .catch((err) => this.$log.error(err));
      CompanyService.getCompanyProfile()
        .then((profile) => {
          this.sector = profile;
          CompanyService.getOdometer(profile.id)
            .then((odometer) => {
              this.odometer = odometer.percentage;
              this.odometerDimensions = odometer.dimensions;
            })
            .catch((err) => this.$log.error(err));
        })
        .catch((err) => this.$log.error(err));
      CompanyService.getRankingSize()
        .then((ranking) => {
          this.rankingClientSize = ranking;
        })
        .catch((err) => this.$log.error(err));
      dtService
        .getDti(userId, surveyId)
        .then((dti) => {
          this.dti = dti;
          this.dtiFacilitador =
            (this.dti.dimensions.find((e) => e.name == "Facilitadores").idx *
              100) /
            (this.dti.dimensions.find((e) => e.name == "Facilitadores").value *
              100);
          this.selectedDimension = dti.dimensions[0];
          this.percentage.value = (this.dti.score * 10).toFixed(0);
          this.dimensions = [
            {
              value: this.toFixed(
                (this.dti.dimensions.find((e) => e.name == "Modelo de Negocio")
                  .idx *
                  100) /
                  28,
                1
              ),
              name: this.dti.dimensions
                .find((e) => e.name == "Modelo de Negocio")
                .name.toUpperCase(),
              image: "bars.svg",
              description: this.dimensions[0].description,
              id: this.dti.dimensions.find((e) => e.name == "Modelo de Negocio")
                .id,
            },
            {
              value: this.toFixed(
                (this.dti.dimensions.find((e) => e.name == "Mentalidad").idx *
                  100) /
                  29,
                1
              ),
              name: this.dti.dimensions
                .find((e) => e.name == "Mentalidad")
                .name.toUpperCase(),
              image: "console.svg",
              description: this.dimensions[1].description,
              id: this.dti.dimensions.find((e) => e.name == "Mentalidad").id,
            },
            {
              value: this.toFixed(
                (this.dti.dimensions.find((e) => e.name == "Orquestación").idx *
                  100) /
                  21,
                1
              ),
              name: this.dti.dimensions
                .find((e) => e.name == "Orquestación")
                .name.toUpperCase(),
              image: "users.svg",
              description: this.dimensions[2].description,
              id: this.dti.dimensions.find((e) => e.name == "Orquestación").id,
            },
            {
              value: this.toFixed(
                (this.dti.dimensions.find((e) => e.name == "Facilitadores")
                  .idx *
                  100) /
                  22,
                1
              ),
              name: this.dti.dimensions
                .find((e) => e.name == "Facilitadores")
                .name.toUpperCase(),
              image: "barsup.svg",
              description: this.dimensions[3].description,
              id: this.dti.dimensions.find((e) => e.name == "Facilitadores").id,
            },
          ];
          this.odometerDti = Math.round(
            (this.dti.dimensions.find((e) => e.name == "Facilitadores").idx *
              100) /
              (this.dti.dimensions.find((e) => e.name == "Facilitadores")
                .value *
                100)
          );
          this.series = [
            {
              data: [
                (this.dti.dimensions.find((e) => e.name == "Orquestación").idx *
                  100 *
                  10) /
                  21,
                (this.dti.dimensions.find((e) => e.name == "Modelo de Negocio")
                  .idx *
                  100 *
                  10) /
                  28,
                (this.dti.dimensions.find((e) => e.name == "Facilitadores")
                  .idx *
                  100 *
                  10) /
                  22,
                (this.dti.dimensions.find((e) => e.name == "Mentalidad").idx *
                  100 *
                  10) /
                  29,
              ],
            },
          ];
          setTimeout(() => {
            document.getElementsByClassName(
              "apexcharts-legend"
            )[0].style.visibility = "hidden";
          }, 500);

          dtService
            .getRanking("SPECIALIST")
            .then((response) => {
              this.rankingGlobal = response.map((e) => {
                e.name = "";
                return e;
              });
              let temp = this.rankingGlobal;
              temp.forEach((e, i) => {
                CompanyService.getCompanyName(e.clientTributaryId)
                  .then((companyName) => {
                    this.rankingGlobal[i].name = companyName;
                  })
                  .catch(() => {
                    this.rankingGlobal[i].name = "Sin nombre";
                  });
              });
              this.finishLoading();
            })
            .catch((err) => {
              this.$log.error(err);
            });
          dtService
            .getPosition()
            .then((response) => {
              this.rankingGlobalNumber = response;
            })
            .catch((err) => {
              this.$log.error(err);
            });
        })
        .catch((err) => {
          this.$log.error(err);
        });
    },
  },
  computed: {
    ...mapGetters("UserStore", ["getPercentage"]),
    clientLevel() {
      let modelo = this.dti.dimensions.find(
        (e) => e.name == "Modelo de Negocio"
      );
      if (modelo) {
        let percentage = modelo.subdimensions.find((e) => e.name == "Cliente");
        if (percentage) {
          let value = (percentage.idx * 10 * 100) / (percentage.value * 100);
          if (value < 41) {
            return "Básico";
          } else if (value < 61) {
            return "Inicial";
          } else if (value < 81) {
            return "Estratégico";
          } else if (value > 80) {
            return "Competitivo";
          }
        }
      }
      return "";
    },
    worse() {
      let temp = this.dimensions;
      temp.sort(function (a, b) {
        if (a.value < b.value) {
          return -1;
        }
        if (a.value > b.value) {
          return 1;
        }
        return 0;
      });
      return temp[0];
    },
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
